// third_party/blink/public/mojom/feature_policy/policy_value.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FEATURE_POLICY_POLICY_VALUE_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FEATURE_POLICY_POLICY_VALUE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/feature_policy/policy_value.mojom-shared.h"
#include "third_party/blink/public/mojom/feature_policy/policy_value.mojom-forward.h"
#include <string>
#include <vector>




#include "third_party/blink/common/feature_policy/policy_value_mojom_traits.h"
#include "third_party/blink/public/common/common_export.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace blink {
namespace mojom {





class BLINK_COMMON_EXPORT PolicyValue {
 public:
  using DataView = PolicyValueDataView;
  using Data_ = internal::PolicyValue_Data;
  using Tag = Data_::PolicyValue_Tag;

  static PolicyValuePtr New() {
    return PolicyValuePtr(base::in_place);
  }
  // Construct an instance holding |null_value|.
  static PolicyValuePtr
  NewNullValue(
      bool null_value) {
    auto result = PolicyValuePtr(base::in_place);
    result->set_null_value(std::move(null_value));
    return result;
  }
  // Construct an instance holding |bool_value|.
  static PolicyValuePtr
  NewBoolValue(
      bool bool_value) {
    auto result = PolicyValuePtr(base::in_place);
    result->set_bool_value(std::move(bool_value));
    return result;
  }
  // Construct an instance holding |dec_double_value|.
  static PolicyValuePtr
  NewDecDoubleValue(
      double dec_double_value) {
    auto result = PolicyValuePtr(base::in_place);
    result->set_dec_double_value(std::move(dec_double_value));
    return result;
  }
  // Construct an instance holding |enum_value|.
  static PolicyValuePtr
  NewEnumValue(
      int32_t enum_value) {
    auto result = PolicyValuePtr(base::in_place);
    result->set_enum_value(std::move(enum_value));
    return result;
  }

  template <typename U>
  static PolicyValuePtr From(const U& u) {
    return mojo::TypeConverter<PolicyValuePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PolicyValue>::Convert(*this);
  }

  PolicyValue();
  ~PolicyValue();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = PolicyValuePtr>
  PolicyValuePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, PolicyValue>::value>::type* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  Tag which() const {
    return tag_;
  }


  
  bool is_null_value() const { return tag_ == Tag::NULL_VALUE; }

  
  bool get_null_value() const {
    DCHECK(tag_ == Tag::NULL_VALUE);
    return data_.null_value;
  }

  
  void set_null_value(
      bool null_value);
  
  bool is_bool_value() const { return tag_ == Tag::BOOL_VALUE; }

  
  bool get_bool_value() const {
    DCHECK(tag_ == Tag::BOOL_VALUE);
    return data_.bool_value;
  }

  
  void set_bool_value(
      bool bool_value);
  
  bool is_dec_double_value() const { return tag_ == Tag::DEC_DOUBLE_VALUE; }

  
  double get_dec_double_value() const {
    DCHECK(tag_ == Tag::DEC_DOUBLE_VALUE);
    return data_.dec_double_value;
  }

  
  void set_dec_double_value(
      double dec_double_value);
  
  bool is_enum_value() const { return tag_ == Tag::ENUM_VALUE; }

  
  int32_t get_enum_value() const {
    DCHECK(tag_ == Tag::ENUM_VALUE);
    return data_.enum_value;
  }

  
  void set_enum_value(
      int32_t enum_value);

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PolicyValue::DataView>(input);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    return mojo::internal::DeserializeImpl<PolicyValue::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

 private:
  union Union_ {
    Union_() {}
    ~Union_() {}
    bool null_value;
    bool bool_value;
    double dec_double_value;
    int32_t enum_value;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void DestroyActive();
  Tag tag_;
  Union_ data_;
};

template <typename UnionPtrType>
PolicyValuePtr PolicyValue::Clone() const {
  // Use UnionPtrType to prevent the compiler from trying to compile this
  // without being asked.
  UnionPtrType rv(New());
  switch (tag_) {
    case Tag::NULL_VALUE:
      rv->set_null_value(mojo::Clone(data_.null_value));
      break;
    case Tag::BOOL_VALUE:
      rv->set_bool_value(mojo::Clone(data_.bool_value));
      break;
    case Tag::DEC_DOUBLE_VALUE:
      rv->set_dec_double_value(mojo::Clone(data_.dec_double_value));
      break;
    case Tag::ENUM_VALUE:
      rv->set_enum_value(mojo::Clone(data_.enum_value));
      break;
  }
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, PolicyValue>::value>::type*>
bool PolicyValue::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::NULL_VALUE:
      return mojo::Equals(data_.null_value, other.data_.null_value);
    case Tag::BOOL_VALUE:
      return mojo::Equals(data_.bool_value, other.data_.bool_value);
    case Tag::DEC_DOUBLE_VALUE:
      return mojo::Equals(data_.dec_double_value, other.data_.dec_double_value);
    case Tag::ENUM_VALUE:
      return mojo::Equals(data_.enum_value, other.data_.enum_value);
  }

  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT UnionTraits<::blink::mojom::PolicyValue::DataView,
                                        ::blink::mojom::PolicyValuePtr> {
  static bool IsNull(const ::blink::mojom::PolicyValuePtr& input) { return !input; }
  static void SetToNull(::blink::mojom::PolicyValuePtr* output) { output->reset(); }

  static ::blink::mojom::PolicyValue::Tag GetTag(const ::blink::mojom::PolicyValuePtr& input) {
    return input->which();
  }

  static  bool null_value(const ::blink::mojom::PolicyValuePtr& input) {
    return input->get_null_value();
  }

  static  bool bool_value(const ::blink::mojom::PolicyValuePtr& input) {
    return input->get_bool_value();
  }

  static  double dec_double_value(const ::blink::mojom::PolicyValuePtr& input) {
    return input->get_dec_double_value();
  }

  static  int32_t enum_value(const ::blink::mojom::PolicyValuePtr& input) {
    return input->get_enum_value();
  }

  static bool Read(::blink::mojom::PolicyValue::DataView input, ::blink::mojom::PolicyValuePtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FEATURE_POLICY_POLICY_VALUE_MOJOM_H_