// third_party/blink/public/mojom/loader/previews_resource_loading_hints.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_PREVIEWS_RESOURCE_LOADING_HINTS_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_PREVIEWS_RESOURCE_LOADING_HINTS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/blink/public/mojom/loader/previews_resource_loading_hints.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "third_party/blink/public/mojom/optimization_guide/optimization_guide.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "base/component_export.h"




namespace blink {
namespace mojom {
class PreviewsResourceLoadingHintsDataView;

class CompressPublicImagesHintsDataView;

class LiteVideoHintDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::PreviewsResourceLoadingHintsDataView> {
  using Data = ::blink::mojom::internal::PreviewsResourceLoadingHints_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::blink::mojom::CompressPublicImagesHintsDataView> {
  using Data = ::blink::mojom::internal::CompressPublicImagesHints_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::blink::mojom::LiteVideoHintDataView> {
  using Data = ::blink::mojom::internal::LiteVideoHint_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {
// Interface base classes. They are used for type safety check.
class PreviewsResourceLoadingHintsReceiverInterfaceBase {};

using PreviewsResourceLoadingHintsReceiverPtrDataView =
    mojo::InterfacePtrDataView<PreviewsResourceLoadingHintsReceiverInterfaceBase>;
using PreviewsResourceLoadingHintsReceiverRequestDataView =
    mojo::InterfaceRequestDataView<PreviewsResourceLoadingHintsReceiverInterfaceBase>;
using PreviewsResourceLoadingHintsReceiverAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<PreviewsResourceLoadingHintsReceiverInterfaceBase>;
using PreviewsResourceLoadingHintsReceiverAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<PreviewsResourceLoadingHintsReceiverInterfaceBase>;


class PreviewsResourceLoadingHintsDataView {
 public:
  PreviewsResourceLoadingHintsDataView() {}

  PreviewsResourceLoadingHintsDataView(
      internal::PreviewsResourceLoadingHints_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t ukm_source_id() const {
    return data_->ukm_source_id;
  }
  inline void GetSubresourcesToBlockDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSubresourcesToBlock(UserType* output) {
    
    auto* pointer = data_->subresources_to_block.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, context_);
  }
 private:
  internal::PreviewsResourceLoadingHints_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



class CompressPublicImagesHintsDataView {
 public:
  CompressPublicImagesHintsDataView() {}

  CompressPublicImagesHintsDataView(
      internal::CompressPublicImagesHints_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetImageUrlsDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadImageUrls(UserType* output) {
    
    auto* pointer = data_->image_urls.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, context_);
  }
 private:
  internal::CompressPublicImagesHints_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



class LiteVideoHintDataView {
 public:
  LiteVideoHintDataView() {}

  LiteVideoHintDataView(
      internal::LiteVideoHint_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t kilobytes_to_buffer_before_throttle() const {
    return data_->kilobytes_to_buffer_before_throttle;
  }
  int64_t target_downlink_bandwidth_kbps() const {
    return data_->target_downlink_bandwidth_kbps;
  }
  inline void GetTargetDownlinkRttLatencyDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTargetDownlinkRttLatency(UserType* output) {
    
    auto* pointer = data_->target_downlink_rtt_latency.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
  inline void GetMaxThrottlingDelayDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMaxThrottlingDelay(UserType* output) {
    
    auto* pointer = data_->max_throttling_delay.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
 private:
  internal::LiteVideoHint_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::PreviewsResourceLoadingHintsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::PreviewsResourceLoadingHintsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::PreviewsResourceLoadingHints_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->ukm_source_id = Traits::ukm_source_id(input);
    decltype(Traits::subresources_to_block(input)) in_subresources_to_block = Traits::subresources_to_block(input);
    typename decltype((*output)->subresources_to_block)::BaseType::BufferWriter
        subresources_to_block_writer;
    const mojo::internal::ContainerValidateParams subresources_to_block_validate_params(
        0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr));
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
        in_subresources_to_block, buffer, &subresources_to_block_writer, &subresources_to_block_validate_params,
        context);
    (*output)->subresources_to_block.Set(
        subresources_to_block_writer.is_null() ? nullptr : subresources_to_block_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->subresources_to_block.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null subresources_to_block in PreviewsResourceLoadingHints struct");
  }

  static bool Deserialize(::blink::mojom::internal::PreviewsResourceLoadingHints_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::PreviewsResourceLoadingHintsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::CompressPublicImagesHintsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::CompressPublicImagesHintsDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::CompressPublicImagesHints_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::image_urls(input)) in_image_urls = Traits::image_urls(input);
    typename decltype((*output)->image_urls)::BaseType::BufferWriter
        image_urls_writer;
    const mojo::internal::ContainerValidateParams image_urls_validate_params(
        0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr));
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
        in_image_urls, buffer, &image_urls_writer, &image_urls_validate_params,
        context);
    (*output)->image_urls.Set(
        image_urls_writer.is_null() ? nullptr : image_urls_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->image_urls.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null image_urls in CompressPublicImagesHints struct");
  }

  static bool Deserialize(::blink::mojom::internal::CompressPublicImagesHints_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::CompressPublicImagesHintsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::LiteVideoHintDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::LiteVideoHintDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::LiteVideoHint_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->kilobytes_to_buffer_before_throttle = Traits::kilobytes_to_buffer_before_throttle(input);
    (*output)->target_downlink_bandwidth_kbps = Traits::target_downlink_bandwidth_kbps(input);
    decltype(Traits::target_downlink_rtt_latency(input)) in_target_downlink_rtt_latency = Traits::target_downlink_rtt_latency(input);
    typename decltype((*output)->target_downlink_rtt_latency)::BaseType::BufferWriter
        target_downlink_rtt_latency_writer;
    mojo::internal::Serialize<::mojo_base::mojom::TimeDeltaDataView>(
        in_target_downlink_rtt_latency, buffer, &target_downlink_rtt_latency_writer, context);
    (*output)->target_downlink_rtt_latency.Set(
        target_downlink_rtt_latency_writer.is_null() ? nullptr : target_downlink_rtt_latency_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->target_downlink_rtt_latency.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null target_downlink_rtt_latency in LiteVideoHint struct");
    decltype(Traits::max_throttling_delay(input)) in_max_throttling_delay = Traits::max_throttling_delay(input);
    typename decltype((*output)->max_throttling_delay)::BaseType::BufferWriter
        max_throttling_delay_writer;
    mojo::internal::Serialize<::mojo_base::mojom::TimeDeltaDataView>(
        in_max_throttling_delay, buffer, &max_throttling_delay_writer, context);
    (*output)->max_throttling_delay.Set(
        max_throttling_delay_writer.is_null() ? nullptr : max_throttling_delay_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->max_throttling_delay.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null max_throttling_delay in LiteVideoHint struct");
  }

  static bool Deserialize(::blink::mojom::internal::LiteVideoHint_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::LiteVideoHintDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void PreviewsResourceLoadingHintsDataView::GetSubresourcesToBlockDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->subresources_to_block.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, context_);
}


inline void CompressPublicImagesHintsDataView::GetImageUrlsDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->image_urls.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, context_);
}


inline void LiteVideoHintDataView::GetTargetDownlinkRttLatencyDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->target_downlink_rtt_latency.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}
inline void LiteVideoHintDataView::GetMaxThrottlingDelayDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->max_throttling_delay.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_PREVIEWS_RESOURCE_LOADING_HINTS_MOJOM_SHARED_H_