// third_party/blink/public/mojom/tokens/tokens.mojom-shared-internal.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_TOKENS_TOKENS_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_TOKENS_TOKENS_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"



namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {
class LocalFrameToken_Data;
class RemoteFrameToken_Data;
class DedicatedWorkerToken_Data;
class ServiceWorkerToken_Data;
class SharedWorkerToken_Data;
class AnimationWorkletToken_Data;
class AudioWorkletToken_Data;
class LayoutWorkletToken_Data;
class PaintWorkletToken_Data;
class PortalToken_Data;
class V8ContextToken_Data;
class FrameToken_Data;
class WorkerToken_Data;
class WorkletToken_Data;
class ExecutionContextToken_Data;

#pragma pack(push, 1)


class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) FrameToken_Data {
 public:
  // Used to identify Mojom Union Data Classes.
  typedef void MojomUnionDataType;

  FrameToken_Data() {}
  // Do nothing in the destructor since it won't be called when it is a
  // non-inlined union.
  ~FrameToken_Data() {}

  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameToken_Data));
      new (data()) FrameToken_Data();
    }

    void AllocateInline(mojo::internal::Buffer* serialization_buffer,
                        void* ptr) {
      const char* start = static_cast<const char*>(
          serialization_buffer->data());
      const char* slot = static_cast<const char*>(ptr);
      DCHECK_GT(slot, start);
      serialization_buffer_ = serialization_buffer;
      index_ = slot - start;
      new (data()) FrameToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameToken_Data>(index_);
    }
    FrameToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context,
                       bool inlined);

  bool is_null() const { return size == 0; }

  void set_null() {
    size = 0U;
    tag = static_cast<FrameToken_Tag>(0);
    data.unknown = 0U;
  }

  enum class FrameToken_Tag : uint32_t {

    
    LOCAL_FRAME_TOKEN,
    
    REMOTE_FRAME_TOKEN,
  };

  // A note on layout:
  // "Each non-static data member is allocated as if it were the sole member of
  // a struct." - Section 9.5.2 ISO/IEC 14882:2011 (The C++ Spec)
  union MOJO_ALIGNAS(8) Union_ {
    Union_() : unknown(0) {}
    mojo::internal::Pointer<internal::LocalFrameToken_Data> f_local_frame_token;
    mojo::internal::Pointer<internal::RemoteFrameToken_Data> f_remote_frame_token;
    uint64_t unknown;
  };

  uint32_t size;
  FrameToken_Tag tag;
  Union_ data;
};
static_assert(sizeof(FrameToken_Data) == mojo::internal::kUnionDataSize,
              "Bad sizeof(FrameToken_Data)");


class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) WorkerToken_Data {
 public:
  // Used to identify Mojom Union Data Classes.
  typedef void MojomUnionDataType;

  WorkerToken_Data() {}
  // Do nothing in the destructor since it won't be called when it is a
  // non-inlined union.
  ~WorkerToken_Data() {}

  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WorkerToken_Data));
      new (data()) WorkerToken_Data();
    }

    void AllocateInline(mojo::internal::Buffer* serialization_buffer,
                        void* ptr) {
      const char* start = static_cast<const char*>(
          serialization_buffer->data());
      const char* slot = static_cast<const char*>(ptr);
      DCHECK_GT(slot, start);
      serialization_buffer_ = serialization_buffer;
      index_ = slot - start;
      new (data()) WorkerToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WorkerToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WorkerToken_Data>(index_);
    }
    WorkerToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context,
                       bool inlined);

  bool is_null() const { return size == 0; }

  void set_null() {
    size = 0U;
    tag = static_cast<WorkerToken_Tag>(0);
    data.unknown = 0U;
  }

  enum class WorkerToken_Tag : uint32_t {

    
    DEDICATED_WORKER_TOKEN,
    
    SERVICE_WORKER_TOKEN,
    
    SHARED_WORKER_TOKEN,
  };

  // A note on layout:
  // "Each non-static data member is allocated as if it were the sole member of
  // a struct." - Section 9.5.2 ISO/IEC 14882:2011 (The C++ Spec)
  union MOJO_ALIGNAS(8) Union_ {
    Union_() : unknown(0) {}
    mojo::internal::Pointer<internal::DedicatedWorkerToken_Data> f_dedicated_worker_token;
    mojo::internal::Pointer<internal::ServiceWorkerToken_Data> f_service_worker_token;
    mojo::internal::Pointer<internal::SharedWorkerToken_Data> f_shared_worker_token;
    uint64_t unknown;
  };

  uint32_t size;
  WorkerToken_Tag tag;
  Union_ data;
};
static_assert(sizeof(WorkerToken_Data) == mojo::internal::kUnionDataSize,
              "Bad sizeof(WorkerToken_Data)");


class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) WorkletToken_Data {
 public:
  // Used to identify Mojom Union Data Classes.
  typedef void MojomUnionDataType;

  WorkletToken_Data() {}
  // Do nothing in the destructor since it won't be called when it is a
  // non-inlined union.
  ~WorkletToken_Data() {}

  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WorkletToken_Data));
      new (data()) WorkletToken_Data();
    }

    void AllocateInline(mojo::internal::Buffer* serialization_buffer,
                        void* ptr) {
      const char* start = static_cast<const char*>(
          serialization_buffer->data());
      const char* slot = static_cast<const char*>(ptr);
      DCHECK_GT(slot, start);
      serialization_buffer_ = serialization_buffer;
      index_ = slot - start;
      new (data()) WorkletToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WorkletToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WorkletToken_Data>(index_);
    }
    WorkletToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context,
                       bool inlined);

  bool is_null() const { return size == 0; }

  void set_null() {
    size = 0U;
    tag = static_cast<WorkletToken_Tag>(0);
    data.unknown = 0U;
  }

  enum class WorkletToken_Tag : uint32_t {

    
    ANIMATION_WORKLET_TOKEN,
    
    AUDIO_WORKLET_TOKEN,
    
    LAYOUT_WORKLET_TOKEN,
    
    PAINT_WORKLET_TOKEN,
  };

  // A note on layout:
  // "Each non-static data member is allocated as if it were the sole member of
  // a struct." - Section 9.5.2 ISO/IEC 14882:2011 (The C++ Spec)
  union MOJO_ALIGNAS(8) Union_ {
    Union_() : unknown(0) {}
    mojo::internal::Pointer<internal::AnimationWorkletToken_Data> f_animation_worklet_token;
    mojo::internal::Pointer<internal::AudioWorkletToken_Data> f_audio_worklet_token;
    mojo::internal::Pointer<internal::LayoutWorkletToken_Data> f_layout_worklet_token;
    mojo::internal::Pointer<internal::PaintWorkletToken_Data> f_paint_worklet_token;
    uint64_t unknown;
  };

  uint32_t size;
  WorkletToken_Tag tag;
  Union_ data;
};
static_assert(sizeof(WorkletToken_Data) == mojo::internal::kUnionDataSize,
              "Bad sizeof(WorkletToken_Data)");


class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) ExecutionContextToken_Data {
 public:
  // Used to identify Mojom Union Data Classes.
  typedef void MojomUnionDataType;

  ExecutionContextToken_Data() {}
  // Do nothing in the destructor since it won't be called when it is a
  // non-inlined union.
  ~ExecutionContextToken_Data() {}

  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ExecutionContextToken_Data));
      new (data()) ExecutionContextToken_Data();
    }

    void AllocateInline(mojo::internal::Buffer* serialization_buffer,
                        void* ptr) {
      const char* start = static_cast<const char*>(
          serialization_buffer->data());
      const char* slot = static_cast<const char*>(ptr);
      DCHECK_GT(slot, start);
      serialization_buffer_ = serialization_buffer;
      index_ = slot - start;
      new (data()) ExecutionContextToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ExecutionContextToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ExecutionContextToken_Data>(index_);
    }
    ExecutionContextToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context,
                       bool inlined);

  bool is_null() const { return size == 0; }

  void set_null() {
    size = 0U;
    tag = static_cast<ExecutionContextToken_Tag>(0);
    data.unknown = 0U;
  }

  enum class ExecutionContextToken_Tag : uint32_t {

    
    LOCAL_FRAME_TOKEN,
    
    DEDICATED_WORKER_TOKEN,
    
    SERVICE_WORKER_TOKEN,
    
    SHARED_WORKER_TOKEN,
    
    ANIMATION_WORKLET_TOKEN,
    
    AUDIO_WORKLET_TOKEN,
    
    LAYOUT_WORKLET_TOKEN,
    
    PAINT_WORKLET_TOKEN,
  };

  // A note on layout:
  // "Each non-static data member is allocated as if it were the sole member of
  // a struct." - Section 9.5.2 ISO/IEC 14882:2011 (The C++ Spec)
  union MOJO_ALIGNAS(8) Union_ {
    Union_() : unknown(0) {}
    mojo::internal::Pointer<internal::LocalFrameToken_Data> f_local_frame_token;
    mojo::internal::Pointer<internal::DedicatedWorkerToken_Data> f_dedicated_worker_token;
    mojo::internal::Pointer<internal::ServiceWorkerToken_Data> f_service_worker_token;
    mojo::internal::Pointer<internal::SharedWorkerToken_Data> f_shared_worker_token;
    mojo::internal::Pointer<internal::AnimationWorkletToken_Data> f_animation_worklet_token;
    mojo::internal::Pointer<internal::AudioWorkletToken_Data> f_audio_worklet_token;
    mojo::internal::Pointer<internal::LayoutWorkletToken_Data> f_layout_worklet_token;
    mojo::internal::Pointer<internal::PaintWorkletToken_Data> f_paint_worklet_token;
    uint64_t unknown;
  };

  uint32_t size;
  ExecutionContextToken_Tag tag;
  Union_ data;
};
static_assert(sizeof(ExecutionContextToken_Data) == mojo::internal::kUnionDataSize,
              "Bad sizeof(ExecutionContextToken_Data)");
class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) LocalFrameToken_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(LocalFrameToken_Data));
      new (data()) LocalFrameToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    LocalFrameToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<LocalFrameToken_Data>(index_);
    }
    LocalFrameToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> value;

 private:
  LocalFrameToken_Data();
  ~LocalFrameToken_Data() = delete;
};
static_assert(sizeof(LocalFrameToken_Data) == 16,
              "Bad sizeof(LocalFrameToken_Data)");
// Used by LocalFrameToken::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct LocalFrameToken_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  LocalFrameToken_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~LocalFrameToken_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    LocalFrameToken_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    LocalFrameToken_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) RemoteFrameToken_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemoteFrameToken_Data));
      new (data()) RemoteFrameToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemoteFrameToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemoteFrameToken_Data>(index_);
    }
    RemoteFrameToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> value;

 private:
  RemoteFrameToken_Data();
  ~RemoteFrameToken_Data() = delete;
};
static_assert(sizeof(RemoteFrameToken_Data) == 16,
              "Bad sizeof(RemoteFrameToken_Data)");
// Used by RemoteFrameToken::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct RemoteFrameToken_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  RemoteFrameToken_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~RemoteFrameToken_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    RemoteFrameToken_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    RemoteFrameToken_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) DedicatedWorkerToken_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DedicatedWorkerToken_Data));
      new (data()) DedicatedWorkerToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DedicatedWorkerToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DedicatedWorkerToken_Data>(index_);
    }
    DedicatedWorkerToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> value;

 private:
  DedicatedWorkerToken_Data();
  ~DedicatedWorkerToken_Data() = delete;
};
static_assert(sizeof(DedicatedWorkerToken_Data) == 16,
              "Bad sizeof(DedicatedWorkerToken_Data)");
// Used by DedicatedWorkerToken::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct DedicatedWorkerToken_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  DedicatedWorkerToken_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~DedicatedWorkerToken_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    DedicatedWorkerToken_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    DedicatedWorkerToken_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) ServiceWorkerToken_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerToken_Data));
      new (data()) ServiceWorkerToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerToken_Data>(index_);
    }
    ServiceWorkerToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> value;

 private:
  ServiceWorkerToken_Data();
  ~ServiceWorkerToken_Data() = delete;
};
static_assert(sizeof(ServiceWorkerToken_Data) == 16,
              "Bad sizeof(ServiceWorkerToken_Data)");
// Used by ServiceWorkerToken::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct ServiceWorkerToken_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  ServiceWorkerToken_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~ServiceWorkerToken_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    ServiceWorkerToken_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    ServiceWorkerToken_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) SharedWorkerToken_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SharedWorkerToken_Data));
      new (data()) SharedWorkerToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SharedWorkerToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SharedWorkerToken_Data>(index_);
    }
    SharedWorkerToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> value;

 private:
  SharedWorkerToken_Data();
  ~SharedWorkerToken_Data() = delete;
};
static_assert(sizeof(SharedWorkerToken_Data) == 16,
              "Bad sizeof(SharedWorkerToken_Data)");
// Used by SharedWorkerToken::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct SharedWorkerToken_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  SharedWorkerToken_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~SharedWorkerToken_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    SharedWorkerToken_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    SharedWorkerToken_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) AnimationWorkletToken_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AnimationWorkletToken_Data));
      new (data()) AnimationWorkletToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AnimationWorkletToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AnimationWorkletToken_Data>(index_);
    }
    AnimationWorkletToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> value;

 private:
  AnimationWorkletToken_Data();
  ~AnimationWorkletToken_Data() = delete;
};
static_assert(sizeof(AnimationWorkletToken_Data) == 16,
              "Bad sizeof(AnimationWorkletToken_Data)");
// Used by AnimationWorkletToken::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct AnimationWorkletToken_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  AnimationWorkletToken_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~AnimationWorkletToken_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    AnimationWorkletToken_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    AnimationWorkletToken_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) AudioWorkletToken_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioWorkletToken_Data));
      new (data()) AudioWorkletToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioWorkletToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioWorkletToken_Data>(index_);
    }
    AudioWorkletToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> value;

 private:
  AudioWorkletToken_Data();
  ~AudioWorkletToken_Data() = delete;
};
static_assert(sizeof(AudioWorkletToken_Data) == 16,
              "Bad sizeof(AudioWorkletToken_Data)");
// Used by AudioWorkletToken::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct AudioWorkletToken_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  AudioWorkletToken_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~AudioWorkletToken_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    AudioWorkletToken_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    AudioWorkletToken_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) LayoutWorkletToken_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(LayoutWorkletToken_Data));
      new (data()) LayoutWorkletToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    LayoutWorkletToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<LayoutWorkletToken_Data>(index_);
    }
    LayoutWorkletToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> value;

 private:
  LayoutWorkletToken_Data();
  ~LayoutWorkletToken_Data() = delete;
};
static_assert(sizeof(LayoutWorkletToken_Data) == 16,
              "Bad sizeof(LayoutWorkletToken_Data)");
// Used by LayoutWorkletToken::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct LayoutWorkletToken_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  LayoutWorkletToken_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~LayoutWorkletToken_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    LayoutWorkletToken_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    LayoutWorkletToken_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) PaintWorkletToken_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PaintWorkletToken_Data));
      new (data()) PaintWorkletToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PaintWorkletToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PaintWorkletToken_Data>(index_);
    }
    PaintWorkletToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> value;

 private:
  PaintWorkletToken_Data();
  ~PaintWorkletToken_Data() = delete;
};
static_assert(sizeof(PaintWorkletToken_Data) == 16,
              "Bad sizeof(PaintWorkletToken_Data)");
// Used by PaintWorkletToken::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct PaintWorkletToken_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  PaintWorkletToken_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~PaintWorkletToken_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    PaintWorkletToken_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    PaintWorkletToken_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) PortalToken_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PortalToken_Data));
      new (data()) PortalToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PortalToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PortalToken_Data>(index_);
    }
    PortalToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> value;

 private:
  PortalToken_Data();
  ~PortalToken_Data() = delete;
};
static_assert(sizeof(PortalToken_Data) == 16,
              "Bad sizeof(PortalToken_Data)");
// Used by PortalToken::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct PortalToken_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  PortalToken_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~PortalToken_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    PortalToken_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    PortalToken_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(TOKENS_MOJOM_SHARED) V8ContextToken_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(V8ContextToken_Data));
      new (data()) V8ContextToken_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    V8ContextToken_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<V8ContextToken_Data>(index_);
    }
    V8ContextToken_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> value;

 private:
  V8ContextToken_Data();
  ~V8ContextToken_Data() = delete;
};
static_assert(sizeof(V8ContextToken_Data) == 16,
              "Bad sizeof(V8ContextToken_Data)");
// Used by V8ContextToken::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct V8ContextToken_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  V8ContextToken_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~V8ContextToken_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    V8ContextToken_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    V8ContextToken_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_TOKENS_TOKENS_MOJOM_SHARED_INTERNAL_H_