// third_party/blink/public/mojom/widget/screen_info.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WIDGET_SCREEN_INFO_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WIDGET_SCREEN_INFO_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/widget/screen_info.mojom-shared.h"
#include "third_party/blink/public/mojom/widget/screen_info.mojom-forward.h"
#include "third_party/blink/public/mojom/widget/screen_orientation.mojom-forward.h"
#include "ui/gfx/geometry/mojom/geometry.mojom.h"
#include "ui/gfx/mojom/display_color_spaces.mojom.h"
#include <string>
#include <vector>




#include "third_party/blink/public/common/widget/screen_info_mojom_traits.h"
#include "third_party/blink/public/common/common_export.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace blink {
namespace mojom {








class BLINK_COMMON_EXPORT ScreenInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ScreenInfo, T>::value>;
  using DataView = ScreenInfoDataView;
  using Data_ = internal::ScreenInfo_Data;

  template <typename... Args>
  static ScreenInfoPtr New(Args&&... args) {
    return ScreenInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ScreenInfoPtr From(const U& u) {
    return mojo::TypeConverter<ScreenInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ScreenInfo>::Convert(*this);
  }


  ScreenInfo();

  ScreenInfo(
      float device_scale_factor,
      const ::gfx::DisplayColorSpaces& display_color_spaces,
      uint32_t depth,
      uint32_t depth_per_component,
      bool is_monochrome,
      uint32_t display_frequency,
      const ::gfx::Rect& rect,
      const ::gfx::Rect& available_rect,
      ::blink::mojom::ScreenOrientation orientation_type,
      uint16_t orientation_angle);

  ~ScreenInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ScreenInfoPtr>
  ScreenInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ScreenInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ScreenInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ScreenInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ScreenInfo_UnserializedMessageContext<
            UserType, ScreenInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ScreenInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ScreenInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ScreenInfo_UnserializedMessageContext<
            UserType, ScreenInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ScreenInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  float device_scale_factor;
  
  ::gfx::DisplayColorSpaces display_color_spaces;
  
  uint32_t depth;
  
  uint32_t depth_per_component;
  
  bool is_monochrome;
  
  uint32_t display_frequency;
  
  ::gfx::Rect rect;
  
  ::gfx::Rect available_rect;
  
  ::blink::mojom::ScreenOrientation orientation_type;
  
  uint16_t orientation_angle;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ScreenInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ScreenInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ScreenInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ScreenInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
ScreenInfoPtr ScreenInfo::Clone() const {
  return New(
      mojo::Clone(device_scale_factor),
      mojo::Clone(display_color_spaces),
      mojo::Clone(depth),
      mojo::Clone(depth_per_component),
      mojo::Clone(is_monochrome),
      mojo::Clone(display_frequency),
      mojo::Clone(rect),
      mojo::Clone(available_rect),
      mojo::Clone(orientation_type),
      mojo::Clone(orientation_angle)
  );
}

template <typename T, ScreenInfo::EnableIfSame<T>*>
bool ScreenInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->device_scale_factor, other_struct.device_scale_factor))
    return false;
  if (!mojo::Equals(this->display_color_spaces, other_struct.display_color_spaces))
    return false;
  if (!mojo::Equals(this->depth, other_struct.depth))
    return false;
  if (!mojo::Equals(this->depth_per_component, other_struct.depth_per_component))
    return false;
  if (!mojo::Equals(this->is_monochrome, other_struct.is_monochrome))
    return false;
  if (!mojo::Equals(this->display_frequency, other_struct.display_frequency))
    return false;
  if (!mojo::Equals(this->rect, other_struct.rect))
    return false;
  if (!mojo::Equals(this->available_rect, other_struct.available_rect))
    return false;
  if (!mojo::Equals(this->orientation_type, other_struct.orientation_type))
    return false;
  if (!mojo::Equals(this->orientation_angle, other_struct.orientation_angle))
    return false;
  return true;
}

template <typename T, ScreenInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.device_scale_factor, rhs.device_scale_factor))
    return true;
  if (std::less<>{}(rhs.device_scale_factor, lhs.device_scale_factor))
    return false;
  if (std::less<>{}(lhs.display_color_spaces, rhs.display_color_spaces))
    return true;
  if (std::less<>{}(rhs.display_color_spaces, lhs.display_color_spaces))
    return false;
  if (std::less<>{}(lhs.depth, rhs.depth))
    return true;
  if (std::less<>{}(rhs.depth, lhs.depth))
    return false;
  if (std::less<>{}(lhs.depth_per_component, rhs.depth_per_component))
    return true;
  if (std::less<>{}(rhs.depth_per_component, lhs.depth_per_component))
    return false;
  if (std::less<>{}(lhs.is_monochrome, rhs.is_monochrome))
    return true;
  if (std::less<>{}(rhs.is_monochrome, lhs.is_monochrome))
    return false;
  if (std::less<>{}(lhs.display_frequency, rhs.display_frequency))
    return true;
  if (std::less<>{}(rhs.display_frequency, lhs.display_frequency))
    return false;
  if (std::less<>{}(lhs.rect, rhs.rect))
    return true;
  if (std::less<>{}(rhs.rect, lhs.rect))
    return false;
  if (std::less<>{}(lhs.available_rect, rhs.available_rect))
    return true;
  if (std::less<>{}(rhs.available_rect, lhs.available_rect))
    return false;
  if (std::less<>{}(lhs.orientation_type, rhs.orientation_type))
    return true;
  if (std::less<>{}(rhs.orientation_type, lhs.orientation_type))
    return false;
  if (std::less<>{}(lhs.orientation_angle, rhs.orientation_angle))
    return true;
  if (std::less<>{}(rhs.orientation_angle, lhs.orientation_angle))
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::ScreenInfo::DataView,
                                         ::blink::mojom::ScreenInfoPtr> {
  static bool IsNull(const ::blink::mojom::ScreenInfoPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::ScreenInfoPtr* output) { output->reset(); }

  static decltype(::blink::mojom::ScreenInfo::device_scale_factor) device_scale_factor(
      const ::blink::mojom::ScreenInfoPtr& input) {
    return input->device_scale_factor;
  }

  static const decltype(::blink::mojom::ScreenInfo::display_color_spaces)& display_color_spaces(
      const ::blink::mojom::ScreenInfoPtr& input) {
    return input->display_color_spaces;
  }

  static decltype(::blink::mojom::ScreenInfo::depth) depth(
      const ::blink::mojom::ScreenInfoPtr& input) {
    return input->depth;
  }

  static decltype(::blink::mojom::ScreenInfo::depth_per_component) depth_per_component(
      const ::blink::mojom::ScreenInfoPtr& input) {
    return input->depth_per_component;
  }

  static decltype(::blink::mojom::ScreenInfo::is_monochrome) is_monochrome(
      const ::blink::mojom::ScreenInfoPtr& input) {
    return input->is_monochrome;
  }

  static decltype(::blink::mojom::ScreenInfo::display_frequency) display_frequency(
      const ::blink::mojom::ScreenInfoPtr& input) {
    return input->display_frequency;
  }

  static const decltype(::blink::mojom::ScreenInfo::rect)& rect(
      const ::blink::mojom::ScreenInfoPtr& input) {
    return input->rect;
  }

  static const decltype(::blink::mojom::ScreenInfo::available_rect)& available_rect(
      const ::blink::mojom::ScreenInfoPtr& input) {
    return input->available_rect;
  }

  static decltype(::blink::mojom::ScreenInfo::orientation_type) orientation_type(
      const ::blink::mojom::ScreenInfoPtr& input) {
    return input->orientation_type;
  }

  static decltype(::blink::mojom::ScreenInfo::orientation_angle) orientation_angle(
      const ::blink::mojom::ScreenInfoPtr& input) {
    return input->orientation_angle;
  }

  static bool Read(::blink::mojom::ScreenInfo::DataView input, ::blink::mojom::ScreenInfoPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WIDGET_SCREEN_INFO_MOJOM_H_